
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>如何实现超高并发的无锁缓存？ / iVAN</title>

    <meta name="description" content="如何实现超高并发的无锁缓存？ 一.需求缘起 [业务场景] 有一类写多读少的业务场景:大部分请求是对数据进行修改,少部分请求对数据进行读取. 例子1:滴滴打车,某个司机地理位置信息的变化(可能每几秒钟有一个修改),以及司机地理位置的读取(用户打车的时候查看某个司机的地理位置). void SetDriverInfo(long driver_id, DriverInfoi); // 大量请求调用修改司机信息,可能主要是GPS位置的修改 DriverInfo GetDriverInfo(long driver_id);  // 少">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">如何实现超高并发的无锁缓存？</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>一、需求缘起</p>
<p>【业务场景】</p>
<p>有一类写多读少的业务场景：大部分请求是对数据进行修改，少部分请求对数据进行读取。</p>
<p>例子1：滴滴打车，某个司机地理位置信息的变化（可能每几秒钟有一个修改），以及司机地理位置的读取（用户打车的时候查看某个司机的地理位置）。</p>
<p>void SetDriverInfo(long driver_id, DriverInfoi); // 大量请求调用修改司机信息，可能主要是GPS位置的修改</p>
<p>DriverInfo GetDriverInfo(long driver_id);  // 少量请求查询司机信息</p>
<p> </p>
<p>例子2：统计计数的变化，某个url的访问次数，用户某个行为的反作弊计数（计数值在不停的变）以及读取（只有少数时刻会读取这类数据）。</p>
<p>void AddCountByType(long type); // 大量增加某个类型的计数，修改比较频繁</p>
<p>long GetCountByType(long type); // 少量返回某个类型的计数</p>
<p> </p>
<p>【底层实现】</p>
<p>具体到底层的实现，往往是一个Map（本质是一个定长key，定长value的缓存结构）来存储司机的信息，或者某个类型的计数。</p>
<p>Map&lt;driver_id, DriverInfo&gt;</p>
<p>Map&lt;type, count&gt;</p>
<p> </p>
<p>【临界资源】</p>
<p>这个Map存储了所有信息，当并发读写访问时，它作为临界资源，在读写之前，一般要进行加锁操作，以司机信息存储为例：</p>
<p>void SetDriverInfo(long driver_id, DriverInfoinfo){</p>
<p>         WriteLock (m_lock);</p>
<p>         Map&lt;driver_id&gt;= info;</p>
<p>         UnWriteLock(m_lock);</p>
<p>}</p>
<p> </p>
<p>DriverInfo GetDriverInfo(long driver_id){</p>
<p>         DriverInfo t;</p>
<p>         ReadLock(m_lock);</p>
<p>         t= Map&lt;driver_id&gt;;</p>
<p>         UnReadLock(m_lock);</p>
<p>         return t;</p>
<p>}</p>
<p> </p>
<p>【并发锁瓶颈】</p>
<p>假设滴滴有100w司机同时在线，每个司机没5秒更新一次经纬度状态，那么每秒就有20w次写并发操作。假设滴滴日订单1000w个，平均每秒大概也有300个下单，对应到查询并发量，可能是1000级别的并发读操作。</p>
<p>上述实现方案没有任何问题，但在并发量很大的时候（每秒20w写，1k读），锁m_lock会成为潜在瓶颈，在这类高并发环境下写多读少的业务仓井，如何来进行优化，是本文将要讨论的问题。</p>
<p> </p>
<p>二、水平切分+锁粒度优化</p>
<p>上文中之所以锁冲突严重，是因为所有司机都公用一把锁，锁的粒度太粗（可以认为是一个数据库的“库级别锁”），是否可能进行水平拆分（类似于数据库里的分库），把一个库锁变成多个库锁，来提高并发，降低锁冲突呢？显然是可以的，把1个Map水平切分成多个Map即可：</p>
<p>void SetDriverInfo(long driver_id, DriverInfoinfo){</p>
<p>         i= driver_id % N; // 水平拆分成N份，N个Map，N个锁</p>
<p>         WriteLock (m_lock [i]);  //锁第i把锁</p>
<p>         Map[i]&lt;driver_id&gt;= info;  // 操作第i个Map</p>
<p>         UnWriteLock (m_lock[i]); // 解锁第i把锁</p>
<p>}</p>
<p> </p>
<p>每个Map的并发量（变成了1/N）和数据量都降低（变成了1/N）了，所以理论上，锁冲突会成平方指数降低。</p>
<p>分库之后，仍然是库锁，有没有办法变成数据库层面所谓的“行级锁”呢，难道要把x条记录变成x个Map吗，这显然是不现实的。</p>
<p> </p>
<p>三、MAP变Array+最细锁粒度优化</p>
<p>假设driver_id是递增生成的，并且缓存的内存比较大，是可以把Map优化成Array，而不是拆分成N个Map，是有可能把锁的粒度细化到最细的（每个记录一个锁）。</p>
<p>void SetDriverInfo(long driver_id, DriverInfoinfo){</p>
<p>         index= driver_id;</p>
<p>         WriteLock (m_lock [index]);  //超级大内存，一条记录一个锁，锁行锁</p>
<p>         Array[index]= info; //driver_id就是Array下标</p>
<p>         UnWriteLock (m_lock[index]); // 解锁行锁</p>
<p>}</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9qcGcvM3hzRlJneDRrSHFKNWxBU3NxNFI0eUJFaFVXNHdpYUVHZ0RSaWFTcWJIOW16ZHF2ZWt2VUZ4WjZxSU0wWnM0bVF5ZEtvQXppYld4cWlhRkRvbmhFZFJqQ293LzY0MD93eF9mbXQ9anBlZyZhbXA7d3hmcm9tPTUmYW1wO3d4X2xhenk9MQ==.jpg"><br />和上一个方案相比，这个方案使得锁冲突降到了最低，但锁资源大增，在数据量非常大的情况下，一般不这么搞。数据量比较小的时候，可以一个元素一个锁的（典型的是连接池，每个连接有一个锁表示连接是否可用）。</p>
<p> </p>
<p>上文中提到的另一个例子，用户操作类型计数，操作类型是有限的，即使一个type一个锁，锁的冲突也可能是很高的，还没有方法进一步提高并发呢？</p>
<p> </p>
<p>四、把锁去掉，变成无锁缓存</p>
<p>【无锁的结果】</p>
<p>void AddCountByType(long type /*, int count*/){</p>
<p>         //不加锁</p>
<p>         Array[type]++; // 计数++</p>
<p>         //Array[type] += count; // 计数增加count</p>
<p>}</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9qcGcvM3hzRlJneDRrSHFKNWxBU3NxNFI0eUJFaFVXNHdpYUVHMXhNelNkVGY5MVFJTUFjeG5uSW54NVhUR1o3dWNJQUI3SXRiQVNHTG9HTE9vaWEyNDZLYmFWZy82NDA/d3hfZm10PWpwZWcmYW1wO3d4ZnJvbT01JmFtcDt3eF9sYXp5PTE=.jpg"><br />如果这个缓存不加锁，当然可以达到最高的并发，但是多线程对缓存中同一块定长数据进行操作时，有可能出现不一致的数据块，这个方案为了提高性能，牺牲了一致性。在读取计数时，获取到了错误的数据，是不能接受的（作为缓存，允许cache miss，却不允许读脏数据）。</p>
<p> </p>
<p>【脏数据是如何产生的】</p>
<p>这个并发写的脏数据是如何产生的呢，详见下图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9qcGcvM3hzRlJneDRrSHFKNWxBU3NxNFI0eUJFaFVXNHdpYUVHbEZQM0p6eGN2MVBJMHZDZ3dkV1pkUVFpY1hrdk9XdWg2bmJwR2hKaWIwbVp2NHVNVVI4ZkUyOXcvNjQwP3d4X2ZtdD1qcGVnJmFtcDt3eGZyb209NSZhbXA7d3hfbGF6eT0x.jpg"><br />1）线程1对缓存进行操作，对key想要写入value1</p>
<p>2）线程2对缓存进行操作，对key想要写入value2</p>
<p>3）如果不加锁，线程1和线程2对同一个定长区域进行一个并发的写操作，<strong>可能每个线程写成功一半，导致出现脏数据产生</strong>，最终的结果即不是value1也不是value2，而是一个乱七八糟的不符合预期的值value-unexpected。</p>
<p> </p>
<p>【数据完整性问题】</p>
<p>并发写入的数据分别是value1和value2，读出的数据是value-unexpected，数据的篡改，这本质上是一个数据完整性的问题。通常如何保证数据的完整性呢？</p>
<p>例子1：运维如何保证，从中控机分发到上线机上的二进制没有被篡改？</p>
<p>回答：md5</p>
<p>例子2：即时通讯系统中，如何保证接受方收到的消息，就是发送方发送的消息？</p>
<p>回答：发送方除了发送消息本身，还要发送消息的签名，接收方收到消息后要校验签名，以确保消息是完整的，未被篡改。</p>
<p>当当当当 =&gt; “签名”是一种常见的保证数据完整性的常见方案。</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbW1iaXoucXBpYy5jbi9tbWJpel9qcGcvM3hzRlJneDRrSHFKNWxBU3NxNFI0eUJFaFVXNHdpYUVHR0NaQ1h3MU15cDhQdG5RM3ZiU2JSNkJLaWM0SWxSaWNvTnlEcEdPVGoyV1BFMjVsM3d0UnNGR1EvNjQwP3d4X2ZtdD1qcGVnJmFtcDt3eGZyb209NSZhbXA7d3hfbGF6eT0x.jpg"><br />【加上签名之后的流程】</p>
<p>加上签名之后，不但缓存要写入定长value本身，还要写入定长签名（例如16bitCRC校验）：</p>
<p>1）线程1对缓存进行操作，对key想要写入value1，写入签名v1-sign</p>
<p>2）线程2对缓存进行操作，对key想要写入value2，写入签名v2-sign</p>
<p>3）如果不加锁，线程1和线程2对同一个定长区域进行一个并发的写操作，可能每个线程写成功一半，导致出现脏数据产生，最终的结果即不是value1也不是value2，而是一个乱七八糟的不符合预期的值value-unexpected，但签名，一定是v1-sign或者v2-sign中的任意一个 </p>
<p>4）数据读取的时候，不但要取出value，还要像消息接收方收到消息一样，校验一下签名，<strong>如果发现签名不一致，缓存则返回NULL，即cache miss。</strong></p>
<p> </p>
<p>当然，对应到司机地理位置，与URL访问计数的case，除了内存缓存之前，肯定需要timer对缓存中的数据定期落盘，写入数据库，如果cache miss，可以从数据库中读取数据。</p>
<p> </p>
<p>五、总结</p>
<p>在【超高并发】，【写多读少】，【定长value】的【业务缓存】场景下：</p>
<p>1）可以通过<strong>水平拆分</strong>来降低锁冲突</p>
<p>2）可以通过<strong>Map转Array</strong>的方式来最小化锁冲突，一条记录一个锁</p>
<p>3）可以<strong>把锁去掉</strong>，最大化并发，但带来的数据完整性的破坏</p>
<p>4）可以通过签名的方式保证数据的完整性，实现<strong>无锁缓存</strong></p>
<p><strong><br /></strong></p>
<p><b>来源：中生代技术</b></p>
<p><b></b></p>
<p><b><a href="https://mp.weixin.qq.com/s/uAzkMNaZTiNZkUBAwVPmGA" rel="external nofollow noreferrer">原文链接</a></b></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-17 02:33:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/type/" title="type">type</a>, <a href="https://www.iamivan.net/tag/index/" title="index">index</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>如何实现超高并发的无锁缓存？的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMgRgAb.html" rel="bookmark">无锁并发框架Disruptor</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 在逛并发编程网的时候,看到了并发框架Disruptor译文这个系列文章. Martin Fowler在自己网站上写了一篇LMAX架构(译文)的文章,在文章中他介绍了LMAX是一种新型零售金融交易平台,它能够以很低的延迟产生大量交易.这个系统是建立在JVM平台上,其核心是一个业务逻辑处理器,它能够在一个线程里每秒处理6百万订单.业务逻辑处理器完全是运行在内存中,使用事件源驱动方式.业务逻辑处理器的核心是Disruptor. Disruptor它是一个开源的并发框架,能够在无锁的情况下实现网络			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxWkBOb.html" rel="bookmark">无锁并发和无等待并发的对比分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址:作者:rethinkdb  译者:sooerr 校对:方腾飞 有两种非阻塞线程同步算法,即无锁和无等待,这两种算法经常会产生混淆. 在无锁系统中,当任何特定的运算被阻塞的时候,所有CPU可以继续处理其他的运算.换种方式说,在无锁系统中,当给定线程被其他线程阻塞的时候,所有CPU可以不停的继续处理其他工作.无锁算法大大增加系统整体的吞吐量,因为它只偶尔会增加一定的交易延迟.大部分高端数据库系统是基于无锁算法而构造的,以满足不同级别. 相反,无等待算法保证了所有CPU在连续处理有效工作的时			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MywN3dz.html" rel="bookmark">使用JAVA实现高并发无锁数据库操作步骤分享&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 并发中如何无锁.一个很简单的思路,把并发转化成为单线程.Java的Disruptor就是一个很好的例子.如果用java的concurrentCollection类去做,原理就是启动一个线程,跑一个Queue,并发的时候,任务压入Queue,线程轮训读取这个Queue,然后一个个顺序执行. 在这个设计模式下,任何并发都会变成了单线程操作,而且速度非常快.现在的node.js, 或者比较普通的ARPG服务端都是这个设计,&quot;大循环&quot;架构.这样,我们原来的系统就有了2个环境:并发环境 +			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPWd1p.html" rel="bookmark">并发无锁队列学习之一【开篇】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.前言 队列在计算机中非常重要的一种数据结构,尤其在操作系统中.队列典型的特征是先进先出(FIFO),符合流水线业务流程.在进程间通信.网络通信之间经常采用队列做缓存,缓解数据处理压力.结合自己在工作中遇到的队列问题,总结一下对不同场景下的队列实现.根据操作队列的场景分为:单生产者--单消费者.多生产者--单消费者.单生产者--多消费者.多生产者--多消费者四大模型.其实后面三种的队列,可以归纳为一种多对多.根据队列中数据分为:队列中的数据是定长的.队列中的数据是变长的. 2.队列操作模型 (			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQPa7Qz.html" rel="bookmark">C&num;算法之基于无锁的C&num;并发队列实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近开始学习无锁编程,和传统的基于Lock的算法相比,无锁编程具有其独特的优点,Angel Lucifer 的关于无锁编程一文对此有详细的描述. 无锁编程的目标是在不使用Lock的前提下保证并发过程中共享数据的一致性,其主要的实现基础是CAS 操作,也就是compare_and_swap,通过处理器提供的指令,可以原子地更新共享数据,并同时监测其他线 程的干扰,.Net中的对应实现是InterLocked.CompareExchange函数. 既然不使用Lock,那在无锁编程中要时刻注意的是,代			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1lO55b.html" rel="bookmark">基于锁的并发算法 vs 无锁的并发算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接 作者:Martin Thompson  译者:曹姚君 校对: 方腾飞 上周在由Heinz Kabutz通过JCrete 组织的开放空间会议(unconference)上,我参加一个新的java规范 JSR166 StampedLock的审查会议.StampedLock 是为了解决多个readers 并发访问共享状态时,系统出现的内存地址竞争问题.在设计上通过使用乐观的读操作,StampedLock 比ReentrantReadWriteLock 更加高效: 在会议期间,我突然意思到两点			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdm014z.html" rel="bookmark">Java 高并发四：无锁详细介绍&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在[高并发Java 一] 前言中已经提到了无锁的概念,由于在jdk源码中有大量的无锁应用,所以在这里介绍下无锁. 1 无锁类的原理详解 1.1 CAS CAS算法的过程是这样:它包含3个参数CAS(V,E,N).V表示要更新的变量,E表示预期值,N表示新值.仅当V 值等于E值时,才会将V的值设为N,如果V值和E值不同,则说明已经有其他线程做了更新,则当前线程什么 都不做.最后,CAS返回当前V的真实值.CAS操作是抱着乐观的态度进行的,它总是认为自己可以成功完成 操作.当多个线程同时使用CAS操			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVNKgDz.html" rel="bookmark">并发编程（三）： 使用C&plus;&plus;11实现无锁stack（lock-free stack&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前几篇文章,我们讨论了如何使用mutex保护数据及使用使用condition variable在多线程中进行同步.然而,使用mutex将会导致一下问题: 等待互斥锁会消耗宝贵的时间 - 有时候是很多时间.这种延迟会损害系统的scalability.尤其是在现在可用的core越多越多的情况下. 低优先级的线程可以获得互斥锁,因此阻碍需要同一互斥锁的高优先级线程.这个问题称为优先级倒置(priority inversion ). 可能因为分配的时间片结束,持有互斥锁的线程被取消调度.这对于等待同一互			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQVgWp.html" rel="bookmark">Disruptor&lpar;无锁并发框架&rpar;-发布</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:http://blog.codeaholics.org/2011/the-disruptor-lock-free-publishing/ 译者:罗立树 假如你生活在另外一个星球,我们最近开源了一套高性能的基于消息传递的开源框架. 下面我给大家介绍一下如何将消息通过Ring buffer在无锁的情况下进行处理. 在深入介绍之前,可以先快速阅读一下Trish发表的文章,该文章介绍了ring buffer和其工作原理. 这篇文章的要点如下: 1.ring buffer是由一个大数组组成的. 2.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDwY6p.html" rel="bookmark" class="title">CSS3布局模式&colon;伸缩布局盒&lpar;Flexbox&rpar;</a>
					<div>
						文章简介:作者长期以来使用表格.浮动.行内块元素和其他 CSS 属性来布局网站内容.然而,这些并不是为复杂的页面和网页应用而设计的.不管是简单的垂直居中,还是灵活的网格布局都很难靠一己之力轻易实现,因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPxX8p.html" rel="bookmark" class="title">J2ME中实现可伸展目录树TreeList</a>
					<div>
						J2ME里面有自带的List类,但是功能太弱,没有实现View和Model的分离,所以操作起来比较费事.本来事想写一个Canvas的TreeList,但是画起来算坐标又太麻烦,所以选取了一个折中的方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAGR2z.html" rel="bookmark" class="title">javascript设计模式交流&lpar;一&rpar; ：Singleton Pattern</a>
					<div>
						javascript|设计  即使是简单的脚本语言,应用良好的模式可以得到非常&quot;优美&quot;的代码和较高的效率.尤其是对于交互要求较高的B/S系统,非常有必要用设计模式来优化代码. 单件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNDloz.html" rel="bookmark" class="title">如何获得asp页面的载入时间（转）</a>
					<div>
						页面 如何获得asp页面的载入时间 &lt;!--- How can I time the execution speed of my ASP pages to the millisecond? -- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOvm3p.html" rel="bookmark" class="title">Tag属性的妙用</a>
					<div>
						今天,注意了一下VB.NET中所有的控件,几乎都有同一个属性:Tag属性,试了下发现使用它,可以达到许多意想不到的效果. 在编写程序时,我们经常要控制很多不同控件的属性,例如我们要将20个TextBo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2o4QM.html" rel="bookmark" class="title">HTML 5 前端框架jQuery Mobile使用教程</a>
					<div>
						1. 简介 jQuery Mobile是由(MT)Media Temple联合多家移动设备厂商以及软件企业共同发起的针对触屏智能手 机与平板电脑的Web应用的前端开发框架. jQuery Mobile ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myr4jJp.html" rel="bookmark" class="title">OAuth学习之基于DotNetOpenAuth实现Client Credentials Grant</a>
					<div>
						Client Credentials Grant是指直接由Client向Authorization Server请求access token,无需用户(Resource Owner)的授权.比如我们提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEllxAz.html" rel="bookmark" class="title">跟ASP&period;NET MVC一起使用jQuery</a>
					<div>
						jQuery是一款容易上手的JavaScript库,任何Web开发平台都可以使用,它跟 ASP.NET MVC框架的结合尤为引人瞩目.James Estes曾在InfoQ上发表过一篇文 章,名为jQu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6a8gz.html" rel="bookmark" class="title">可爱的Python&colon; 用于PalmOS的Python</a>
					<div>
						让我以 Pippy 好消息和坏消息的笑话方式来介绍它.关于 Pippy 的好消息是 Python 程序员可以完全在 Palm 上编写和运行程序.而且,对于版本 0.7,Pippy 变得更快.更稳定以及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRvlnz.html" rel="bookmark" class="title">JAVA基础培训&lpar;2&rpar; 熟悉方法的调用</a>
					<div>
						我们上一个只用直接的输出语句,打印出可Hello World 查看复制到剪切板打印 System.out.println(&quot;Hello World!&quot;); 这里我们讲使用方法,来实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPJjOz.html" rel="bookmark" class="title">pscs4快捷键大全</a>
					<div>
						  pscs4快捷键大全 Ctrl + A 全选 Ctrl + D 取消选择 Shift + Ctrl + D 恢复选择 Ctrl + X 剪切 Ctrl + C 复制 Ctrl + V 粘贴 Shi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOqYRM.html" rel="bookmark" class="title">简单排除VLAN无线上网交换机故障</a>
					<div>
						  在无线网络组成中,很多设备的使用都值得大家详细了解一下.那么今天我们主要谈论一下VLAN无线上网交换机故障的问题.如下是一位网友的经验分享:单位一个办公区所在的两个部门VLAN出现了一个很奇怪的问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRweVkp.html" rel="bookmark" class="title">苹果OSX上怎么移除Safari 标签页的浏览记录图标？</a>
					<div>
						  当你在 OS X Yosemite 上点击进入 Safari 的 地址栏 时,通常窗口下面就会显示一列网页浏览标签,点击这些记录图标可以快速浏览网页,但有时候用户会觉得看起来太杂乱.想要移除这些图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArNVvp.html" rel="bookmark" class="title">Xargs用法详解&lpar;原创&rpar;</a>
					<div>
						简介之所以能用到这个命令,关键是由于很多命令不支持|管道来传递参数,而日常工作中有有这个必要,所以就有了xargs命令,例如: 这个命令是错误的find /sbin -perm +700 |ls -l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGk45p.html" rel="bookmark" class="title">Form Post提交容量大的数据&lowbar;应用技巧</a>
					<div>
						微软建议用Request.BinaryRead()读取表单数据,但由于这种方法读出的是二进制数据,需要对读出的数据逐字节进行分析,生成有意义的字符串(MSDN上的一段程序就是这样写的,但它并没有考虑诸 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqryab.html" rel="bookmark" class="title">jquery判断复选框是否选中进行答题提示特效&lowbar;jquery</a>
					<div>
						本文实例讲述了jquery判断复选框是否选中进行答题提示特效代码.分享给大家供大家参考.具体如下: 运行效果截图如下: 具体代码如下: 一.实现的原理: 第一步:判断用户选择哪一项,即哪个复选框被选中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrW00xp.html" rel="bookmark" class="title">为什么我们程序员难晋升</a>
					<div>
						今天看到微博上 发 了一个帖子:&quot;内部晋升越来越困难,但是外部来的大P越来越多,所以很多人都选择跳槽&quot;,之后我从三个方面简要的进行了回答:&quot;外面来的总是有包装的,内 部的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NVmWz.html" rel="bookmark" class="title">松耦合和紧耦合的架构设计及性能对比</a>
					<div>
						在最近的一次大数据技术讨论会上,本行业一家公司的技术高管谈到松耦合架构和紧耦合架构的性能表现的话题.正好Laxcus大数据管理系统的设计,从 0.x.1.x到2.x版本,也经历了从紧耦合到松耦合的发展 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3E2lz.html" rel="bookmark" class="title">我的一个朋友过来面试引发我要说的一个小话题</a>
					<div>
						在很多家公司面试,也包括在携程,大多都会被问到一些算法的问题,其中机票事业部的面试,基本上算是算法问题的重灾区,没办法,有几个领导喜欢 用数据结构来考人家,其中包括一些常见数据结构的复杂度以及手写一些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwlNyp.html" rel="bookmark" class="title">Monit：开源服务器监控工具</a>
					<div>
						Monit是一个跨平台的用来监控Unix/linux系统(比如Linux.BSD.OSX.Solaris)的工具.Monit特别易于安装,而且非常轻量级(只有500KB大小),并且不依赖任何第三方程序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQwmVp.html" rel="bookmark" class="title">android-Andriod如何实现漂浮组件效果？</a>
					<div>
						问题描述 Andriod如何实现漂浮组件效果? 如何在android中实现Windows中屏保中的漂浮的泡泡效果,让某个组件在屏幕中自由漂浮这个效果也行!! 请教大家这种功能如何实现?求详细解答 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKY9Jap.html" rel="bookmark" class="title">ios-IOS：在UICollectionView单元添加图片</a>
					<div>
						问题描述 IOS:在UICollectionView单元添加图片 使用UICollectionView生成图片集.UICollectionView 中的UIImage来加载图片.需要在批量选择图片时, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boK4mdb.html" rel="bookmark" class="title">教你用jquery实现iframe自适应高度&lowbar;jquery</a>
					<div>
						iframe代码,注意要写ID 复制代码 代码如下: &lt;iframe src=&quot;test.html&quot; id=&quot;main&quot; width=&quot;700& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0PjLp.html" rel="bookmark" class="title">sharepoint onedrive 同步问题只能同步空的文件夹</a>
					<div>
						问题描述 一直显示在同步1388个,一个多月了都清除缓存,重启,同步新库等等都试过了,就是不行啊,求大神帮助 解决方案 本帖最后由 abc63620292 于 2015-04-29 08:25:16  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnNZaM.html" rel="bookmark" class="title">让数据具有想象力 百分点打造新一代智能引擎</a>
					<div>
						ZD至顶网服务器频道 06月13日 新闻消息:近日,全球知名IT行业分析和咨询服务企业Gartner发布 &quot;Gartner 2016 Cool Vendors in China&quot;报 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jNA3p.html" rel="bookmark" class="title">Shell脚本实现的猜数字小游戏&lowbar;linux shell</a>
					<div>
						生成的密码和用户输入可以接受重复数字. 所以相对一般规则的猜数字可能难度要大不少. 本版本规则: A--数字对,位置也对 B--排除A的结果后,数字对,但位置不对 开始后,系统化初始化一个4位可重复数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jPNvp.html" rel="bookmark" class="title">为非IE浏览器添加mouseenter&comma;mouseleave事件的实现代码&lowbar;javascript技巧</a>
					<div>
						先了解几个事件对象属性 target 指事件源对象,点击嵌套元素最里层的某元素,该元素就是target.IE6/7/8对应的是srcElement. currentTarget 指添加事件handle ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrOnop.html" rel="bookmark" class="title">经验之谈-如何来打造长尾词获得好的流量</a>
					<div>
						1.长尾词文章的质量:文章原创程度.文章是否有被高权重网站转载,即使你是文章首发网站,然而文章被高权重站点转载了那么质量等同于伪原创,甚至是采集.所以网站整站或文章页所在目录权重高低对于长尾词排名影响 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqBmdp.html" rel="bookmark" class="title">Mysql 主从数据库同步&lpar;centos篇&rpar;&lowbar;Mysql</a>
					<div>
						环境: 主服务器:centos 5.2 mysql 5.1.35 源码 IP:192.168.1.22 从服务器:centos 5.2 mysql 5.1.35 源码  IP:192.168.1.33 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0XZOM.html" rel="bookmark" class="title">决心选择vSphere的理由</a>
					<div>
						在迁移到公有云的过程中中小型企业面临着许多抉择,在这两部分系列文章中的第一系列中已经阐述过一些公有云的突出优势,包括节约管理时间.增加数据中心扩展能力.消除安全和可用性顾虑.然而另外一些企业,应该继续 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
